<template>
	<v-container>
		<v-snackbar
			v-model="snack"
			:timeout="timeout"
			top
			color="green"
			class="subtitle-1"
		>Documento actualizado</v-snackbar>
		<v-snackbar v-model="snackEstudio" :timeout="3000" top color="orange" class="subtitle-1">No olvides hacer el estudio socioeconómico.</v-snackbar>
		<p class="text-center display-1">Mis documentos</p>
		<v-form>
			<!-- Renderea formulario nuevo ingreso de talento especial-->
			<v-row
				v-if="typeScholarship === 'talento-especial' && lastScholarship !== penultimateScholarship"
			>
				<!-- obtiene los documentos excepto la imagen -->
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataDocumentsTalentNew" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" width="100%" height="300px"></iframe>
							<div class="mt-3" id="bord" v-if="item.status === 'Aprobado'">
								<p class="pt-2 pb-2 headline text-center white--text">Aprobado</p>
							</div>
							<div v-else>
								<div v-if="item.title !== 'Estudio socioeconómico'">
									<v-file-input
										class="mt-3"
										:prepend-icon="item.icon"
										@change="handler($event,item.model)"
										show-size
										:rules="rulesDocuments"
										label="Selecciona un archivo"
										dense
										rounded
										outlined
										:accept="item.accept"
										required
									/>
									<v-btn
										outlined
										:loading="index === loadbutton ? true : false"
										block
										rounded
										color="green"
										@click="updateDocument(index)"
									>Actualizar documento</v-btn>
								</div>
							</div>
						</v-card-text>
					</v-card>
				</v-col>
				<!-- obtiene la imagen -->
				<v-col cols="12" sm="6" md="4">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandImage">
							<v-card-text>
								<p class="text-center white--text title">{{dataImageTalent.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{dataImageTalent.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<img :src="image" width="100%" height="300px" />
							<div class="mt-3" id="bord" v-if="dataImageTalent.status === 'Aprobado'">
								<p class="pt-2 pb-2 headline text-center white--text">Aprobado</p>
							</div>
							<div v-else>
								<v-file-input
									class="mt-3"
									:prepend-icon="dataImageTalent.icon"
									@change="handler($event,dataImageTalent.model)"
									show-size
									:rules="rulesDocuments"
									label="Selecciona un archivo"
									dense
									rounded
									outlined
									:accept="dataImageTalent.accept"
									required
								/>
								<v-btn
									:loading="loadImage"
									outlined
									block
									rounded
									color="green"
									@click="updateImage"
								>Actualizar documento</v-btn>
							</div>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<!-- Renderea formulario renovacion de talento especial -->
			<v-row
				v-if="typeScholarship === 'talento-especial' && lastScholarship === penultimateScholarship"
			>
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataDocumentsTalentRen" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" width="100%" height="300px"></iframe>
							<div class="mt-3" id="bord" v-if="item.status === 'Aprobado'">
								<p class="pt-2 pb-2 headline text-center white--text">Aprobado</p>
							</div>
							<div v-else>
								<div v-if="item.title !== 'Estudio socioeconómico'">
									<v-file-input
										class="mt-3"
										:prepend-icon="item.icon"
										@change="handler($event,item.model)"
										show-size
										:rules="rulesDocuments"
										label="Selecciona un archivo"
										dense
										rounded
										outlined
										:accept="item.accept"
										required
									/>
									<v-btn
										outlined
										:loading="index === loadbutton ? true : false"
										block
										rounded
										color="green"
										@click="updateDocument(index)"
									>Actualizar documento</v-btn>
								</div>
							</div>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<!-- Renderea el formulario nuevo ingreso para beca diferente de talento especial -->
			<v-row
				v-if="typeScholarship !== 'talento-especial' && lastScholarship !== penultimateScholarship"
			>
				<!-- obtiene los documetos excepto la imagen -->
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataDocumentsNew" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<iframe :src="item.file" width="100%" height="300px"></iframe>
							<div class="mt-3" id="bord" v-if="item.status === 'Aprobado'">
								<p class="pt-2 pb-2 headline text-center white--text">Aprobado</p>
							</div>
							<div v-else>
								<div v-if="item.title !== 'Estudio socioeconómico'">
									<v-file-input
										class="mt-3"
										:prepend-icon="item.icon"
										@change="handler($event,item.model)"
										show-size
										:rules="rulesDocuments"
										label="Selecciona un archivo"
										dense
										rounded
										outlined
										:accept="item.accept"
										required
									/>
									<v-btn
										outlined
										:loading="index === loadbutton ? true : false"
										block
										rounded
										color="green"
										@click="updateDocument(index)"
									>Actualizar documento</v-btn>
								</div>
							</div>
						</v-card-text>
					</v-card>
				</v-col>
				<!-- obtiene la imagen -->
				<v-col cols="12" sm="6" md="4">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandImage">
							<v-card-text>
								<p class="text-center white--text title">{{dataImage.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{dataImage.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<img :src="image" width="100%" height="300px" />
							<div class="mt-3" id="bord" v-if="dataImage.status === 'Aprobado'">
								<p class="pt-2 pb-2 headline text-center white--text">Aprobado</p>
							</div>
							<div v-else>
								<v-file-input
									class="mt-3"
									:prepend-icon="dataImage.icon"
									@change="handler($event,dataImage.model)"
									show-size
									:rules="rulesDocuments"
									label="Selecciona un archivo"
									dense
									rounded
									outlined
									:accept="dataImage.accept"
									required
								/>
								<v-btn
									:loading="loadImage"
									outlined
									block
									rounded
									color="green"
									@click="updateImage"
								>Actualizar documento</v-btn>
							</div>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>
			<!-- Renderea el formulario renovacion para beca diferente de talento especial -->
			<v-row
				v-if="typeScholarship !== 'talento-especial' && lastScholarship === penultimateScholarship"
			>
				<v-col cols="12" sm="6" md="4" v-for="(item,index) in dataDocumentsRen" :key="item.title">
					<v-card outlined>
						<v-card color="#c51f2f" height="60" @click="expandDocument(item.file)">
							<v-card-text>
								<p class="text-center white--text title">{{item.title}}</p>
							</v-card-text>
						</v-card>
						<v-card-text>
							<p class="subtitle-1">Descripción: {{item.desc}}</p>
							<!-- Falta la instancia para poder mostrar los archivos en el iframe -->
							<iframe :src="item.file" type="application/pdf" width="100%" height="300px"></iframe>
							<div class="mt-3" id="bord" v-if="item.status === 'Aprobado'">
								<p class="pt-2 pb-2 headline text-center white--text">Aprobado</p>
							</div>
							<div v-else>
								<div v-if="item.title !== 'Estudio socioeconómico'">
									<v-file-input
										class="mt-3"
										:prepend-icon="item.icon"
										@change="handler($event,item.model)"
										show-size
										:rules="rulesDocuments"
										label="Selecciona un archivo"
										dense
										rounded
										outlined
										:accept="item.accept"
										required
									/>
									<v-btn
										outlined
										:loading="index === loadbutton ? true : false"
										block
										rounded
										color="green"
										@click="updateDocument(index)"
									>Actualizar documento</v-btn>
								</div>
							</div>
						</v-card-text>
					</v-card>
				</v-col>
			</v-row>

			<v-row justify="center" justify-sm="center">
				<v-col cols="12" sm="3">
					<v-btn color="blue" outlined block :to="{name:'AvailableScholarships'}">Atras</v-btn>
				</v-col>
			</v-row>
		</v-form>

		<ModalDocument :visible="modalDocument" :document="documentToModal" />
		<ModalImage :visible="modalImage" :image="image" />
	</v-container>
</template>

<script>
import ModalDocument from "@/components/student/ModalDocument";
import ModalImage from "@/components/student/ModalImage";
import gql from "graphql-tag";
import { mapMutations, mapState } from "vuex";
import axios from "axios";
import EventBus from "../../bus";

export default {
	name: "FormMyDocuments",
	components: { ModalDocument, ModalImage },
	data: () => ({
		snack: false,
		modalDocument: false,
		snackEstudio:false,
		documentToModal: null,
		modalImage: false,
		image: "",
		timeout: 2000,
		loadImage: false,
		loadbutton: null,
		typeScholarship: "",
		lastScholarship: "",
		penultimateScholarship: "",
		// arrays de nombres para pedir los documentos
		arrayDocumentsTalentNew: [
			"birthAct",
			"ine",
			"curp",
			"reasonLetter",
			"curriculumVitae",
			"qualificationConstancy",
			"studyConstancy",
			"economicIncomes",
			// aqui iba el estudio
			"acknowledgment",
			"socioeconomicStudy"
		],
		arrayDocumentsTalentRen: [
			"ine",
			"qualificationConstancy",
			"studyConstancy",
			// aqui iba el estudio
			"socialService",
			"acknowledgment",
			"socioeconomicStudy"
		],
		arrayDocumentsNew: [
			"birthAct",
			"ine",
			"curp",
			"reasonLetter",
			"curriculumVitae",
			"qualificationConstancy",
			"studyConstancy",
			"economicIncomes",
			"socioeconomicStudy"
		],
		arrayDocumentsRen: [
			"ine",
			"qualificationConstancy",
			"studyConstancy",
			"socialService",
			"socioeconomicStudy"
		],
		// objetos para guardar los archivos
		modelDocumentsTalentNew: {
			acta: {},
			ine: {},
			curp: {},
			carta: {},
			cv: {},
			kardex: {},
			const: {},
			comp: {},
			foto: {},
			reco: {}
		},
		modelDocumentsNew: {
			acta: {},
			ine: {},
			curp: {},
			carta: {},
			cv: {},
			kardex: {},
			const: {},
			comp: {},

			foto: {}
		},
		modelDocumentsTalentRen: {
			ine: {},
			kardex: {},
			const: {},
			ss: {},
			reco: {}
		},
		modelDocumentsRen: {
			ine: {},
			kardex: {},
			const: {},
			ss: {}
		},
		// Arrays para iterar las cards
		dataDocumentsTalentNew: [
			{
				title: "Acta de nacimiento",
				desc: "Acta de nacimiento vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.acta",
				file: "",
				status: ""
			},
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.ine",
				file: "",
				status: ""
			},
			{
				title: "CURP",
				desc: "Clave Única de Registro de Población oficial.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.curp",
				file: "",
				status: ""
			},
			{
				title: "Carta de exposición de motivos",
				desc:
					"Una carta que exponga los motivos para solicitar la beca.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.carta",
				file: "",
				status: ""
			},
			{
				title: "Curriculum vitae",
				desc: "Documento con tu historial profesional.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.cv",
				file: "",
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.kardex",
				file: "",
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.const",
				file: "",
				status: ""
			},
			{
				title: "Comprobante de ingresos",
				desc: "Documento que avala los ingresos familiares.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.comp",
				file: "",
				status: ""
			},
			{
				title: "Premio nacional",
				desc: "Reconocimiento nacional vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentNew.reco",
				file: "",
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				file: "",
				status: ""
			}
		],
		dataImageTalent: {
			title: "Fotografía de la casa",
			desc: "Fotografía frontal de la casa.",
			icon: "fas fa-camera",
			accept: "image/*",
			model: "modelDocumentsTalentNew.foto",
			file: "",
			status: ""
		},
		dataDocumentsNew: [
			{
				title: "Acta de nacimiento",
				desc: "Acta de nacimiento vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.acta",
				file: "",
				status: ""
			},
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.ine",
				file: "",
				status: ""
			},
			{
				title: "CURP",
				desc: "Clave Única de Registro de Población oficial.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.curp",
				file: "",
				status: ""
			},
			{
				title: "Carta de exposición de motivos",
				desc:
					"Una carta que exponga los motivos para solicitar la beca.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.carta",
				file: "",
				status: ""
			},
			{
				title: "Curriculum vitae",
				desc: "Documento con tu historial profesional.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.cv",
				file: "",
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.kardex",
				file: "",
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.const",
				file: "",
				status: ""
			},
			{
				title: "Comprobante de ingresos",
				desc: "Documento que avala los ingresos familiares.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsNew.comp",
				file: "",
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				file: "",
				status: ""
			}
		],
		dataImage: {
			title: "Fotografía de la casa",
			desc: "Fotografía frontal de la casa.",
			icon: "fas fa-camera",
			accept: "image/*",
			model: "modelDocumentsNew.foto",
			file: "",
			status: ""
		},
		dataDocumentsTalentRen: [
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentRen.ine",
				file: "",
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentRen.kardex",
				file: "",
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentRen.const",
				file: "",
				status: ""
			},
			{
				title: "Servicio social",
				desc: "Servicio social del semestre anterior.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentRen.ss",
				file: "",
				status: ""
			},
			{
				title: "Premio nacional",
				desc: "Reconocimiento nacional vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsTalentRen.reco",
				file: "",
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				file: "",
				status: ""
			},
		],
		dataDocumentsRen: [
			{
				title: "INE",
				desc: "Credencial de elector vigente.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsRen.ine",
				file: "",
				status: ""
			},
			{
				title: "Kardex de calificaciones",
				desc: "Constancia de calificaciones generales.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsRen.kardex",
				file: "",
				status: ""
			},
			{
				title: "Comprobante de inscripción",
				desc: "Constancia de estudios.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsRen.const",
				file: "",
				status: ""
			},
			{
				title: "Servicio social",
				desc: "Servicio social del semestre anterior.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				model: "modelDocumentsRen.ss",
				file: "",
				status: ""
			},
			{
				title: "Estudio socioeconómico",
				desc: "Estudio formal de datos socioeconómicos.",
				icon: "fas fa-file-pdf",
				accept: ".pdf",
				file: "",
				status: ""
			}
		],
		// reglas para los documentos
		rulesDocuments: [
			value => !!value || "Campo requerido",
			value =>
				!value ||
				value.size < 1000000 ||
				"El archivo no debe pesar mas de 1 mb"
		]
	}),
	computed: {
		...mapState(["userData"])
	},
	methods: {
		...mapMutations(["saveUserData"]),
		// Obtiene la ultima beca solicitada
		async getLastScholarship() {
			try {
				const last = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							getLastScholarship(curp: $curp) {
								scholarship
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});

				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							findStudent(curp: $curp) {
								scholarshipRecord {
									scholarship
								}
							}
						}
					`,
					variables: {
						curp: this.userData.curp
					}
				});

				this.lastScholarship = last.data.getLastScholarship.scholarship;
				if (data.findStudent.scholarshipRecord.length > 1) {
					this.penultimateScholarship =
						data.findStudent.scholarshipRecord[1].scholarship;
				}

				this.getDocuments();
			} catch (error) {}
		},
		// Obtiene los documentos anteriormente subidos
		async getDocuments() {
			// En caso de que sea nuevo ingreso y talento especial
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				this.getStatusOfDocuments(0);
				this.saveFilesIntoObject(
					this.arrayDocumentsTalentNew,
					this.dataDocumentsTalentNew
				);
				this.getImage();
			}
			// En caso de que sea renovacion y talento especial
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				this.getStatusOfDocuments(1);
				this.saveFilesIntoObject(
					this.arrayDocumentsTalentRen,
					this.dataDocumentsTalentRen
				);
			}
			// En caso de que sea nuevo ingreso y diferente a talento especial
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				this.getStatusOfDocuments(2);
				this.saveFilesIntoObject(
					this.arrayDocumentsNew,
					this.dataDocumentsNew
				);
				this.getImage();
			}
			// En caso de que sea renovación y diferente a talento especial
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				this.getStatusOfDocuments(3);
				this.saveFilesIntoObject(
					this.arrayDocumentsRen,
					this.dataDocumentsRen
				);
			}
		},
		// Obtiene los status de los documentos
		async getStatusOfDocuments(type) {
			try {
				switch (type) {
					case 0:
						const filesTalentNew = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											birthAct {
												status
											}
											ine {
												status
											}
											curp {
												status
											}
											reasonLetter {
												status
											}
											curriculumVitae {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											economicIncomes {
												status
											}
											socioeconomicStudy {
												status
											}
											photoHouse {
												status
											}
											acknowledgment {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.userData.curp
							}
						});
						let arrayDocuments0 = [];
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents.birthAct
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents.ine
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents.curp
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.reasonLetter
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.curriculumVitae
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.studyConstancy
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.economicIncomes
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.acknowledgment
						);
						arrayDocuments0.push(
							filesTalentNew.data.findStudent.documents
								.socioeconomicStudy
						);
						this.dataImageTalent.status =
							filesTalentNew.data.findStudent.documents.photoHouse.status;

						let contStatus0 = 0;
						for (let i of this.dataDocumentsTalentNew) {
							i.status = arrayDocuments0[contStatus0].status;
							contStatus0++;
						}

						break;
					case 1:
						const filesTalentRen = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											ine {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											socialService {
												status
											}
											socioeconomicStudy{
												status
											}
											acknowledgment {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.userData.curp
							}
						});
						let arrayDocuments1 = [];
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents.ine
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.studyConstancy
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.socialService
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.acknowledgment
						);
						arrayDocuments1.push(
							filesTalentRen.data.findStudent.documents
								.socioeconomicStudy
						);
						let contStatus1 = 0;
						for (let i of this.dataDocumentsTalentRen) {
							i.status = arrayDocuments1[contStatus1].status;
							contStatus1++;
						}
						break;
					case 2:
						const filesNew = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											birthAct {
												status
											}
											ine {
												status
											}
											curp {
												status
											}
											reasonLetter {
												status
											}
											curriculumVitae {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											economicIncomes {
												status
											}
											socioeconomicStudy {
												status
											}
											photoHouse {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.userData.curp
							}
						});

						let arrayDocuments2 = [];
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.birthAct
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.ine
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.curp
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.reasonLetter
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.curriculumVitae
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.studyConstancy
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.economicIncomes
						);
						arrayDocuments2.push(
							filesNew.data.findStudent.documents.socioeconomicStudy
						);

						this.dataImage.status =
							filesNew.data.findStudent.documents.photoHouse.status;

						let contStatus2 = 0;
						for (let i of this.dataDocumentsNew) {
							i.status = arrayDocuments2[contStatus2].status;
							contStatus2++;
						}
						break;
					case 3:
						const filesRen = await this.$apollo.query({
							query: gql`
								query($curp: String!) {
									findStudent(curp: $curp) {
										documents {
											ine {
												status
											}
											qualificationConstancy {
												status
											}
											studyConstancy {
												status
											}
											socioeconomicStudy {
												status
											}
											socialService {
												status
											}
										}
									}
								}
							`,
							variables: {
								curp: this.userData.curp
							}
						});

						let arrayDocuments3 = [];
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.ine
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents
								.qualificationConstancy
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.studyConstancy
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.socialService
						);
						arrayDocuments3.push(
							filesRen.data.findStudent.documents.socioeconomicStudy
						);
						
						let contStatus3 = 0;
						for (let i of this.dataDocumentsRen) {
							i.status = arrayDocuments3[contStatus3].status;
							contStatus3++;
						}
						break;
				}
			} catch (error) {}
		},
		// obtiene los archivos dinamicamente y los guarda en los campos files correspondientes
		async saveFilesIntoObject(array, objectData) {
			try {
				let contFile = 0;
				for (let i of array) {
					let response = await axios.get(`/getFile/${i}`, {
						responseType: "blob",
						headers: {
							Accept: "application/pdf",
							Authorization: sessionStorage.getItem("token")
						}
					});
					objectData[contFile].file = window.URL.createObjectURL(
						new Blob([response.data], {
							type: "application/pdf"
						})
					);
					contFile++;
				}
			} catch (error) {}
		},
		// obtiene la imagen y la guarda en los campos files
		async getImage() {
			try {
				const response = await axios.get("/getFile/photoHouse", {
					responseType: "arraybuffer",
					headers: {
						Authorization: sessionStorage.getItem("token")
					}
				});

				const image = window.URL.createObjectURL(
					new Blob([response.data], {
						type: "image/jpeg"
					})
				);
				this.image = image;
			} catch (error) {}
		},
		// Evento que guarda el documento subido en cada variable
		handler(e, i) {
			// En caso de que sea nuevo ingreso y talento especial
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				switch (i) {
					case "modelDocumentsTalentNew.acta":
						this.modelDocumentsTalentNew.acta = e;
						break;
					case "modelDocumentsTalentNew.ine":
						this.modelDocumentsTalentNew.ine = e;
						break;
					case "modelDocumentsTalentNew.curp":
						this.modelDocumentsTalentNew.curp = e;
						break;
					case "modelDocumentsTalentNew.carta":
						this.modelDocumentsTalentNew.carta = e;
						break;
					case "modelDocumentsTalentNew.cv":
						this.modelDocumentsTalentNew.cv = e;
						break;
					case "modelDocumentsTalentNew.kardex":
						this.modelDocumentsTalentNew.kardex = e;
						break;
					case "modelDocumentsTalentNew.const":
						this.modelDocumentsTalentNew.const = e;
						break;
					case "modelDocumentsTalentNew.comp":
						this.modelDocumentsTalentNew.comp = e;
						break;
					case "modelDocumentsTalentNew.foto":
						this.modelDocumentsTalentNew.foto = e;
						break;
					case "modelDocumentsTalentNew.reco":
						this.modelDocumentsTalentNew.reco = e;
						break;
				}
			}
			// En caso de que sea renovacion y talento especial
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				switch (i) {
					case "modelDocumentsTalentRen.ine":
						this.modelDocumentsTalentRen.ine = e;
						break;
					case "modelDocumentsTalentRen.kardex":
						this.modelDocumentsTalentRen.kardex = e;
						break;
					case "modelDocumentsTalentRen.const":
						this.modelDocumentsTalentRen.const = e;
						break;
					case "modelDocumentsTalentRen.ss":
						this.modelDocumentsTalentRen.ss = e;
						break;
					case "modelDocumentsTalentRen.reco":
						this.modelDocumentsTalentRen.reco = e;
						break;
				}
			}
			// En caso de que sea nuevo ingreso y diferente a talento especial
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				switch (i) {
					case "modelDocumentsNew.acta":
						this.modelDocumentsNew.acta = e;
						break;
					case "modelDocumentsNew.ine":
						this.modelDocumentsNew.ine = e;
						break;
					case "modelDocumentsNew.curp":
						this.modelDocumentsNew.curp = e;
						break;
					case "modelDocumentsNew.carta":
						this.modelDocumentsNew.carta = e;
						break;
					case "modelDocumentsNew.cv":
						this.modelDocumentsNew.cv = e;
						break;
					case "modelDocumentsNew.kardex":
						this.modelDocumentsNew.kardex = e;
						break;
					case "modelDocumentsNew.const":
						this.modelDocumentsNew.const = e;
						break;
					case "modelDocumentsNew.comp":
						this.modelDocumentsNew.comp = e;
						break;
					case "modelDocumentsNew.foto":
						this.modelDocumentsNew.foto = e;
						break;
				}
			}
			// En caso de que sea renovación y diferente a talento especial
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				switch (i) {
					case "modelDocumentsRen.ine":
						this.modelDocumentsRen.ine = e;
						break;
					case "modelDocumentsRen.kardex":
						this.modelDocumentsRen.kardex = e;
						break;
					case "modelDocumentsRen.const":
						this.modelDocumentsRen.const = e;
						break;
					case "modelDocumentsRen.ss":
						this.modelDocumentsRen.ss = e;
						break;
				}
			}
		},
		// Envia el documento seleccionado solamente
		async updateDocument(i) {
			// En caso de que sea nuevo ingreso y talento especial
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				let formData = new FormData();
				// agrega el append correspondiente del archivo al formData
				switch (i) {
					case 0:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.acta,
							"acta.pdf"
						);
						break;
					case 1:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.ine,
							"ine.pdf"
						);
						break;
					case 2:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.curp,
							"curp.pdf"
						);
						break;
					case 3:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.carta,
							"carta.pdf"
						);
						break;
					case 4:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.cv,
							"cv.pdf"
						);
						break;
					case 5:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.kardex,
							"kardex.pdf"
						);
						break;
					case 6:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.const,
							"const.pdf"
						);
						break;
					case 7:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.comp,
							"comp.pdf"
						);
						break;
					case 8:
						formData.append(
							"file",
							this.modelDocumentsTalentNew.reco,
							"reco.pdf"
						);
						break;
				}
				// peticion que envia los archivos
				await axios.post("/uploadFiles/single", formData, {
					headers: {
						Authorization: sessionStorage.getItem("token"),
						"Content-Type": "multipart/form-data"
					}
				});
				this.loadbutton = i;
				setTimeout(() => {
					this.snack = true;
					this.loadbutton = null;
					this.getDocuments();
					this.getImage();
				}, 2000);
			}
			// En caso de que sea renovacion y talento especial
			if (
				this.typeScholarship === "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				let formData = new FormData();
				// agrega el append correspondiente del archivo al formData
				switch (i) {
					case 0:
						formData.append(
							"file",
							this.modelDocumentsTalentRen.ine,
							"ine.pdf"
						);
						break;
					case 1:
						formData.append(
							"file",
							this.modelDocumentsTalentRen.kardex,
							"kardex.pdf"
						);
						break;
					case 2:
						formData.append(
							"file",
							this.modelDocumentsTalentRen.const,
							"const.pdf"
						);
						break;
					case 3:
						formData.append(
							"file",
							this.modelDocumentsTalentRen.ss,
							"ss.pdf"
						);
						break;
					case 4:
						formData.append(
							"file",
							this.modelDocumentsTalentRen.reco,
							"reco.pdf"
						);
						break;
				}
				// peticion que envia los archivos
				await axios.post("/uploadFiles/single", formData, {
					headers: {
						Authorization: sessionStorage.getItem("token"),
						"Content-Type": "multipart/form-data"
					}
				});
				this.loadbutton = i;
				setTimeout(() => {
					this.snack = true;
					this.loadbutton = null;
					this.getDocuments();
				}, 2000);
			}
			// En caso de que sea nuevo ingreso y diferente a talento especial
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship !== this.penultimateScholarship
			) {
				let formData = new FormData();
				// agrega el append correspondiente del archivo al formData
				switch (i) {
					case 0:
						formData.append(
							"file",
							this.modelDocumentsNew.acta,
							"acta.pdf"
						);
						break;
					case 1:
						formData.append(
							"file",
							this.modelDocumentsNew.ine,
							"ine.pdf"
						);
						break;
					case 2:
						formData.append(
							"file",
							this.modelDocumentsNew.curp,
							"curp.pdf"
						);
						break;
					case 3:
						formData.append(
							"file",
							this.modelDocumentsNew.carta,
							"carta.pdf"
						);
						break;
					case 4:
						formData.append(
							"file",
							this.modelDocumentsNew.cv,
							"cv.pdf"
						);
						break;
					case 5:
						formData.append(
							"file",
							this.modelDocumentsNew.kardex,
							"kardex.pdf"
						);
						break;
					case 6:
						formData.append(
							"file",
							this.modelDocumentsNew.const,
							"const.pdf"
						);
						break;
					case 7:
						formData.append(
							"file",
							this.modelDocumentsNew.comp,
							"comp.pdf"
						);
						break;
					case 8:
						formData.append(
							"file",
							this.modelDocumentsNew.foto,
							"foto.pdf"
						);
						break;
				}
				// peticion que envia los archivos
				await axios.post("/uploadFiles/single", formData, {
					headers: {
						Authorization: sessionStorage.getItem("token"),
						"Content-Type": "multipart/form-data"
					}
				});
				this.loadbutton = i;
				setTimeout(() => {
					this.snack = true;
					this.loadbutton = null;
					this.getDocuments();
					this.getImage();
				}, 2000);
			}
			// En caso de que sea renovación y diferente a talento especial
			if (
				this.typeScholarship !== "talento-especial" &&
				this.lastScholarship === this.penultimateScholarship
			) {
				let formData = new FormData();
				// agrega el append correspondiente del archivo al formData
				switch (i) {
					case 0:
						formData.append(
							"file",
							this.modelDocumentsRen.ine,
							"ine.pdf"
						);
						break;
					case 1:
						formData.append(
							"file",
							this.modelDocumentsRen.kardex,
							"kardex.pdf"
						);
						break;
					case 2:
						formData.append(
							"file",
							this.modelDocumentsRen.const,
							"const.pdf"
						);
						break;
					case 3:
						formData.append(
							"file",
							this.modelDocumentsRen.ss,
							"ss.pdf"
						);
						break;
				}
				// peticion que envia los archivos
				await axios.post("/uploadFiles/single", formData, {
					headers: {
						Authorization: sessionStorage.getItem("token"),
						"Content-Type": "multipart/form-data"
					}
				});
				this.loadbutton = i;
				setTimeout(() => {
					this.snack = true;
					this.loadbutton = null;
					this.getDocuments();
				}, 2000);
			}
		},
		// Actualiza la imagen
		async updateImage() {
			try {
				// En caso de que sea nuevo ingreso y talento especial
				if (
					this.typeScholarship === "talento-especial" &&
					this.lastScholarship !== this.penultimateScholarship
				) {
					let formData = new FormData();
					formData.append(
						"file",
						this.modelDocumentsTalentNew.foto,
						"photo.jpg"
					);

					await axios.post("/uploadFiles/single", formData, {
						headers: {
							Authorization: sessionStorage.getItem("token"),
							"Content-Type": "multipart/form-data"
						}
					});
					this.loadImage = true;
					setTimeout(() => {
						this.snack = true;
						this.loadImage = null;
						this.getDocuments();
					}, 2000);
				}
				// En caso de que sea nuevo ingreso y diferente a talento especial
				if (
					this.typeScholarship !== "talento-especial" &&
					this.lastScholarship !== this.penultimateScholarship
				) {
					let formData = new FormData();
					formData.append(
						"file",
						this.modelDocumentsNew.foto,
						"photo.jpg"
					);

					await axios.post("/uploadFiles/single", formData, {
						headers: {
							Authorization: sessionStorage.getItem("token"),
							"Content-Type": "multipart/form-data"
						}
					});
					this.loadImage = true;
					setTimeout(() => {
						this.snack = true;
						this.loadImage = null;
						this.getDocuments();
					}, 2000);
				}
			} catch (error) {}
		},
		// expande los documentos
		expandDocument(document) {
			this.documentToModal = document;
			this.modalDocument = true;
		},
		// expande las imagenes
		expandImage() {
			this.modalImage = true;
		},
		// obtiene el status del estudio socioeconomico
		async getSocioeconomicStudy(){
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!){
							findStudent(curp: $curp){
								documents{
									socioeconomicStudy{
										status
									}
								}
							}
						}
					`,
					variables:{
						curp: this.userData.curp
					}
				});

				(data.findStudent.documents === null) ? this.snackEstudio = true : this.snackEstudio = false;
			} catch (error) {}
		}
	},
	created() {
		this.saveUserData();
		this.typeScholarship = this.$route.params.typeScholarship;
		this.getLastScholarship();
		this.getSocioeconomicStudy();
	},
	mounted() {
		EventBus.$on("closeDocumentModalStudent", () => {
			this.modalDocument = false;
		});

		EventBus.$on("closeImageModalStudent", () => {
			this.modalImage = false;
		});
	}
};
</script>

<style scope>
#bord {
	background-color: #72a051;
	border-radius: 32px 32px 32px 32px;
	-moz-border-radius: 32px 32px 32px 32px;
	-webkit-border-radius: 32px 32px 32px 32px;
	border: 0px solid #000000;
}
</style>